{ /* 
   NOTE: must kill definition of memset in asm/string.h or won't match
   (is a macro that expands to different inline memset versions)  
   
   If we can nuke false pos's, warn about uses of pointers, rather than
   just deref's --- should catch a bunch more errors.   
#include <linux/string.h>
 */

#ifdef BSD
#define MC_HACK
#endif
}

sm_header { 
#    define err(s) 						\
	mc_note(mc_stmt, "ERROR:NULL:%d:%d: " s " set by '%s':%d",\
				mc_lineno(mc_v_start_stmt(v)),	\
				mc_lineno(mc_stmt),		\
				mc_identifier(v), 		\
				mc_v_get_data(v), 		\
				mc_lineno(mc_v_start_stmt(v)))

#    define err2(s, fn) 						\
	mc_note(mc_stmt, "ERROR:NULL:%d:%d: " s " set by '%s':%d",\
				mc_lineno(mc_v_start_stmt(v)),	\
				mc_lineno(mc_stmt),		\
				mc_identifier(v), fn,		\
				mc_v_get_data(v), 		\
				mc_lineno(mc_v_start_stmt(v)))

#define null_note(s) mc_note(mc_stmt, "NOTE=NULL: checking '%s' " s , \
					mc_identifier(any_fcall))

#ifdef BSD
#	include "../null/bsd-can-fail.h"
#else
	static int can_fail_p(mc_tree call) { return 1; }
#endif

#       include "libs/mc_process-annotations.h"
        static struct hash_table *null_ht, *null_ignore_ht;
}

sm null_checker {
   /* XXX: this is totally broken: we should be able to use c's qualifiers. */
   decl literal { int } retv; 
   decl any_pointer v1;     // match any ptr
   // 'state' specifies 'v' will have a state
   state decl any_pointer v;
   decl any_scalar sz, priority, c;
   decl any_fn_call any_fcall;
   decl any_parm args;

    init {

	if(mc_is_header_file())
		mc_skip_fn();
	if(!null_ht) {
                char *file =  PREFIX "/" NULL_FILE;

                null_ht = annot_readin(file, 0, -1, -1);
		pi_assert(null_ht, cannot load annotations);

                file = PREFIX "/" IGNORE_FILE;
                null_ignore_ht = annot_readin(file, 0, -1, -1);
		pi_assert(null_ignore_ht, cannot load annotations);
        }
    };
    pat alloc_succ = { ((v = (any)any_fcall(args)) != 0) };
    pat alloc_fail = { ((v = (any)any_fcall(args)) == 0) };
    pat alloc = { v = (any)any_fcall(args) };

   /* need to make these compositions fall out naturally. */
   start:
       alloc_fail ==> true=v.null, false=v.not_null,
	{ null_note("== 0"); mc_v_set_data(v, mc_identifier(any_fcall)); }
     | alloc_succ ==> true=v.not_null, false=v.null,
	{ null_note("!= 0"); mc_v_set_data(v, mc_identifier(any_fcall)); }
     | alloc ==> 
        {
		char *n;
		if((n = mc_identifier(any_fcall)) && annot_is_def(null_ht, n)
		&& !annot_is_def(null_ignore_ht, n) && can_fail_p(any_fcall)) {
			mc_v_set_state(v, unknown);
			mc_v_set_data(v, n);
			null_note("decoupled");
		}
	}
     ;

   v.unknown, v.null, v.not_null:
      { (v == 0) } ==> true = v.null, false = v.not_null
    | { (v != 0) } ==> true = v.not_null, false = v.null 
    ;

   /* Should add in a use to see what else we pick up. */
   v.null: { *(any *)v } ==> 
           v.stop, { err("Using NULL ptr \"%s\" illegally!"); }
	| { memset(v, c, sz) } ==>
           v.stop, { err("Illegal memset of NULL \"%s\"!"); }
        | { any_fcall(args) } ==>
           {
                int i;
                char *n; 

                n = mc_identifier(any_fcall);
                i = mc_get_call_arg(any_fcall, v);
                if(n  && i >= 0
                && (!strncmp(n, "mem", 3) || !strncmp(n, "str", 3))) {
                        err2("Passing NULL ptr \"%s\"! to call \"%s\"!", n); 
                        mc_v_set_state(v, stop);
                }
           }    
	;
 
   v.unknown: { *(any *)v } ==> 
	   /* could give false positives */
           v.stop, { err("Using unknown ptr \"%s\" illegally!"); }
	| { memset(v, c, sz) } ==>
           v.stop, { err("Illegal memset of unknown \"%s\"!"); }
        | { any_fcall(args) } ==>
           {
                int i;
                char *n; 

                n = mc_identifier(any_fcall);
                i = mc_get_call_arg(any_fcall, v);
                if(n  && i >= 0 
                && (!strncmp(n, "mem", 3) || !strncmp(n, "str", 3))) {
                        err2("Passing unknown ptr \"%s\"! to call \"%s\"!", n); 
                        mc_v_set_state(v, stop);
                }
           }    
	;
}
